// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: DischargeAndFuelingDataResponse.proto

package ru.omnicomm.pegasus.messaging.data.responses;

public final class RefuelingResponseParser {
  private RefuelingResponseParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public enum State
      implements com.google.protobuf.ProtocolMessageEnum {
    NORMAL(0, 0),
    LAST(1, 1),
    DEFECTIVE(2, 2),
    ;
    
    
    public final int getNumber() { return value; }
    
    public static State valueOf(int value) {
      switch (value) {
        case 0: return NORMAL;
        case 1: return LAST;
        case 2: return DEFECTIVE;
        default: return null;
      }
    }
    
    public static com.google.protobuf.Internal.EnumLiteMap<State>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static com.google.protobuf.Internal.EnumLiteMap<State>
        internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<State>() {
            public State findValueByNumber(int number) {
              return State.valueOf(number)
    ;        }
          };
    
    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(index);
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.getDescriptor().getEnumTypes().get(0);
    }
    
    private static final State[] VALUES = {
      NORMAL, LAST, DEFECTIVE, 
    };
    public static State valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }
    private final int index;
    private final int value;
    private State(int index, int value) {
      this.index = index;
      this.value = value;
    }
    
    static {
      ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.getDescriptor();
    }
    
    // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.data.responses.State)
  }
  
  public static final class DischargeAndFuelingDataResponse extends
      com.google.protobuf.GeneratedMessage {
    // Use DischargeAndFuelingDataResponse.newBuilder() to construct.
    private DischargeAndFuelingDataResponse() {
      initFields();
    }
    private DischargeAndFuelingDataResponse(boolean noInit) {}
    
    private static final DischargeAndFuelingDataResponse defaultInstance;
    public static DischargeAndFuelingDataResponse getDefaultInstance() {
      return defaultInstance;
    }
    
    public DischargeAndFuelingDataResponse getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_fieldAccessorTable;
    }
    
    public static final class Row extends
        com.google.protobuf.GeneratedMessage {
      // Use Row.newBuilder() to construct.
      private Row() {
        initFields();
      }
      private Row(boolean noInit) {}
      
      private static final Row defaultInstance;
      public static Row getDefaultInstance() {
        return defaultInstance;
      }
      
      public Row getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_fieldAccessorTable;
      }
      
      // required string vehicleId = 101;
      public static final int VEHICLEID_FIELD_NUMBER = 101;
      private boolean hasVehicleId;
      private java.lang.String vehicleId_ = "";
      public boolean hasVehicleId() { return hasVehicleId; }
      public java.lang.String getVehicleId() { return vehicleId_; }
      
      // required string eventName = 102;
      public static final int EVENTNAME_FIELD_NUMBER = 102;
      private boolean hasEventName;
      private java.lang.String eventName_ = "";
      public boolean hasEventName() { return hasEventName; }
      public java.lang.String getEventName() { return eventName_; }
      
      // required double startInterval = 103;
      public static final int STARTINTERVAL_FIELD_NUMBER = 103;
      private boolean hasStartInterval;
      private double startInterval_ = 0D;
      public boolean hasStartInterval() { return hasStartInterval; }
      public double getStartInterval() { return startInterval_; }
      
      // required double finishInterval = 104;
      public static final int FINISHINTERVAL_FIELD_NUMBER = 104;
      private boolean hasFinishInterval;
      private double finishInterval_ = 0D;
      public boolean hasFinishInterval() { return hasFinishInterval; }
      public double getFinishInterval() { return finishInterval_; }
      
      // required double fuelValue = 105;
      public static final int FUELVALUE_FIELD_NUMBER = 105;
      private boolean hasFuelValue;
      private double fuelValue_ = 0D;
      public boolean hasFuelValue() { return hasFuelValue; }
      public double getFuelValue() { return fuelValue_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasVehicleId) return false;
        if (!hasEventName) return false;
        if (!hasStartInterval) return false;
        if (!hasFinishInterval) return false;
        if (!hasFuelValue) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasVehicleId()) {
          output.writeString(101, getVehicleId());
        }
        if (hasEventName()) {
          output.writeString(102, getEventName());
        }
        if (hasStartInterval()) {
          output.writeDouble(103, getStartInterval());
        }
        if (hasFinishInterval()) {
          output.writeDouble(104, getFinishInterval());
        }
        if (hasFuelValue()) {
          output.writeDouble(105, getFuelValue());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasVehicleId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(101, getVehicleId());
        }
        if (hasEventName()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(102, getEventName());
        }
        if (hasStartInterval()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(103, getStartInterval());
        }
        if (hasFinishInterval()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(104, getFinishInterval());
        }
        if (hasFuelValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(105, getFuelValue());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row result;
        
        // Construct using ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row other) {
          if (other == ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.getDefaultInstance()) return this;
          if (other.hasVehicleId()) {
            setVehicleId(other.getVehicleId());
          }
          if (other.hasEventName()) {
            setEventName(other.getEventName());
          }
          if (other.hasStartInterval()) {
            setStartInterval(other.getStartInterval());
          }
          if (other.hasFinishInterval()) {
            setFinishInterval(other.getFinishInterval());
          }
          if (other.hasFuelValue()) {
            setFuelValue(other.getFuelValue());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 810: {
                setVehicleId(input.readString());
                break;
              }
              case 818: {
                setEventName(input.readString());
                break;
              }
              case 825: {
                setStartInterval(input.readDouble());
                break;
              }
              case 833: {
                setFinishInterval(input.readDouble());
                break;
              }
              case 841: {
                setFuelValue(input.readDouble());
                break;
              }
            }
          }
        }
        
        
        // required string vehicleId = 101;
        public boolean hasVehicleId() {
          return result.hasVehicleId();
        }
        public java.lang.String getVehicleId() {
          return result.getVehicleId();
        }
        public Builder setVehicleId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasVehicleId = true;
          result.vehicleId_ = value;
          return this;
        }
        public Builder clearVehicleId() {
          result.hasVehicleId = false;
          result.vehicleId_ = getDefaultInstance().getVehicleId();
          return this;
        }
        
        // required string eventName = 102;
        public boolean hasEventName() {
          return result.hasEventName();
        }
        public java.lang.String getEventName() {
          return result.getEventName();
        }
        public Builder setEventName(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasEventName = true;
          result.eventName_ = value;
          return this;
        }
        public Builder clearEventName() {
          result.hasEventName = false;
          result.eventName_ = getDefaultInstance().getEventName();
          return this;
        }
        
        // required double startInterval = 103;
        public boolean hasStartInterval() {
          return result.hasStartInterval();
        }
        public double getStartInterval() {
          return result.getStartInterval();
        }
        public Builder setStartInterval(double value) {
          result.hasStartInterval = true;
          result.startInterval_ = value;
          return this;
        }
        public Builder clearStartInterval() {
          result.hasStartInterval = false;
          result.startInterval_ = 0D;
          return this;
        }
        
        // required double finishInterval = 104;
        public boolean hasFinishInterval() {
          return result.hasFinishInterval();
        }
        public double getFinishInterval() {
          return result.getFinishInterval();
        }
        public Builder setFinishInterval(double value) {
          result.hasFinishInterval = true;
          result.finishInterval_ = value;
          return this;
        }
        public Builder clearFinishInterval() {
          result.hasFinishInterval = false;
          result.finishInterval_ = 0D;
          return this;
        }
        
        // required double fuelValue = 105;
        public boolean hasFuelValue() {
          return result.hasFuelValue();
        }
        public double getFuelValue() {
          return result.getFuelValue();
        }
        public Builder setFuelValue(double value) {
          result.hasFuelValue = true;
          result.fuelValue_ = value;
          return this;
        }
        public Builder clearFuelValue() {
          result.hasFuelValue = false;
          result.fuelValue_ = 0D;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse.Row)
      }
      
      static {
        defaultInstance = new Row(true);
        ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse.Row)
    }
    
    // required int32 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 0;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // optional string instanceId = 4;
    public static final int INSTANCEID_FIELD_NUMBER = 4;
    private boolean hasInstanceId;
    private java.lang.String instanceId_ = "";
    public boolean hasInstanceId() { return hasInstanceId; }
    public java.lang.String getInstanceId() { return instanceId_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse.Row rows = 201;
    public static final int ROWS_FIELD_NUMBER = 201;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row> rows_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row> getRowsList() {
      return rows_;
    }
    public int getRowsCount() { return rows_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row getRows(int index) {
      return rows_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
    public static final int BLOCKSTATE_FIELD_NUMBER = 300;
    private boolean hasBlockState;
    private ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State blockState_;
    public boolean hasBlockState() { return hasBlockState; }
    public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State getBlockState() { return blockState_; }
    
    // optional int32 blockNumber = 301;
    public static final int BLOCKNUMBER_FIELD_NUMBER = 301;
    private boolean hasBlockNumber;
    private int blockNumber_ = 0;
    public boolean hasBlockNumber() { return hasBlockNumber; }
    public int getBlockNumber() { return blockNumber_; }
    
    private void initFields() {
      blockState_ = ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State.NORMAL;
    }
    public final boolean isInitialized() {
      if (!hasMessageType) return false;
      for (ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row element : getRowsList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasInstanceId()) {
        output.writeString(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row element : getRowsList()) {
        output.writeMessage(201, element);
      }
      if (hasBlockState()) {
        output.writeEnum(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        output.writeInt32(301, getBlockNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasInstanceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row element : getRowsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(201, element);
      }
      if (hasBlockState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(301, getBlockNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.rows_ != java.util.Collections.EMPTY_LIST) {
          result.rows_ =
            java.util.Collections.unmodifiableList(result.rows_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.getDefaultInstance()) return this;
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasInstanceId()) {
          setInstanceId(other.getInstanceId());
        }
        if (!other.rows_.isEmpty()) {
          if (result.rows_.isEmpty()) {
            result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row>();
          }
          result.rows_.addAll(other.rows_);
        }
        if (other.hasBlockState()) {
          setBlockState(other.getBlockState());
        }
        if (other.hasBlockNumber()) {
          setBlockNumber(other.getBlockNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 34: {
              setInstanceId(input.readString());
              break;
            }
            case 1610: {
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addRows(subBuilder.buildPartial());
              break;
            }
            case 2400: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State value = ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(300, rawValue);
              } else {
                setBlockState(value);
              }
              break;
            }
            case 2408: {
              setBlockNumber(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 messageType = 2;
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 0;
        return this;
      }
      
      // optional string instanceId = 4;
      public boolean hasInstanceId() {
        return result.hasInstanceId();
      }
      public java.lang.String getInstanceId() {
        return result.getInstanceId();
      }
      public Builder setInstanceId(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasInstanceId = true;
        result.instanceId_ = value;
        return this;
      }
      public Builder clearInstanceId() {
        result.hasInstanceId = false;
        result.instanceId_ = getDefaultInstance().getInstanceId();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse.Row rows = 201;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row> getRowsList() {
        return java.util.Collections.unmodifiableList(result.rows_);
      }
      public int getRowsCount() {
        return result.getRowsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row getRows(int index) {
        return result.getRows(index);
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.rows_.set(index, value);
        return this;
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.Builder builderForValue) {
        result.rows_.set(index, builderForValue.build());
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row>();
        }
        result.rows_.add(value);
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.Builder builderForValue) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row>();
        }
        result.rows_.add(builderForValue.build());
        return this;
      }
      public Builder addAllRows(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row> values) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row>();
        }
        super.addAll(values, result.rows_);
        return this;
      }
      public Builder clearRows() {
        result.rows_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.data.responses.State blockState = 300;
      public boolean hasBlockState() {
        return result.hasBlockState();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State getBlockState() {
        return result.getBlockState();
      }
      public Builder setBlockState(ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasBlockState = true;
        result.blockState_ = value;
        return this;
      }
      public Builder clearBlockState() {
        result.hasBlockState = false;
        result.blockState_ = ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.State.NORMAL;
        return this;
      }
      
      // optional int32 blockNumber = 301;
      public boolean hasBlockNumber() {
        return result.hasBlockNumber();
      }
      public int getBlockNumber() {
        return result.getBlockNumber();
      }
      public Builder setBlockNumber(int value) {
        result.hasBlockNumber = true;
        result.blockNumber_ = value;
        return this;
      }
      public Builder clearBlockNumber() {
        result.hasBlockNumber = false;
        result.blockNumber_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse)
    }
    
    static {
      defaultInstance = new DischargeAndFuelingDataResponse(true);
      ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.DischargeAndFuelingDataResponse)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n%DischargeAndFuelingDataResponse.proto\022" +
      ",ru.omnicomm.pegasus.messaging.data.resp" +
      "onses\"\373\002\n\037DischargeAndFuelingDataRespons" +
      "e\022\023\n\013messageType\030\002 \002(\005\022\022\n\ninstanceId\030\004 \001" +
      "(\t\022`\n\004rows\030\311\001 \003(\0132Q.ru.omnicomm.pegasus." +
      "messaging.data.responses.DischargeAndFue" +
      "lingDataResponse.Row\022H\n\nblockState\030\254\002 \001(" +
      "\01623.ru.omnicomm.pegasus.messaging.data.r" +
      "esponses.State\022\024\n\013blockNumber\030\255\002 \001(\005\032m\n\003" +
      "Row\022\021\n\tvehicleId\030e \002(\t\022\021\n\teventName\030f \002(",
      "\t\022\025\n\rstartInterval\030g \002(\001\022\026\n\016finishInterv" +
      "al\030h \002(\001\022\021\n\tfuelValue\030i \002(\001*,\n\005State\022\n\n\006" +
      "NORMAL\020\000\022\010\n\004LAST\020\001\022\r\n\tDEFECTIVE\020\002BG\n,ru." +
      "omnicomm.pegasus.messaging.data.response" +
      "sB\027RefuelingResponseParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_descriptor,
              new java.lang.String[] { "MessageType", "InstanceId", "Rows", "BlockState", "BlockNumber", },
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.class,
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_DischargeAndFuelingDataResponse_Row_descriptor,
              new java.lang.String[] { "VehicleId", "EventName", "StartInterval", "FinishInterval", "FuelValue", },
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.class,
              ru.omnicomm.pegasus.messaging.data.responses.RefuelingResponseParser.DischargeAndFuelingDataResponse.Row.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
